
module.exports =
	router:
		cache: false

	timestamps: true

	catchUncaught: true

	server:
		cluster		: null # null, true, false
		workers		: 99 # if 1 or less, will not use the cluster unless cluster is set to true
		port		: 80
		host		: '127.0.0.1'
		socket		: ''
		socketPerms	: 0o0666
		method		: 'port'
		maxSockets	: 20

		busboy: # https://github.com/mscdex/busboy
			limits:
				fileSize: 4 * 1024 * 1024 # bytes

	# Specify an absolute path for the root where findIn, saveTo etc. will resolve from.
	# Defaults to path.dirname require.main.filename
	root: ''

	# DISABLED CURRENTLY. Toggles gzip/deflate compression
	compress : false

	templater:
		#findIn			: null # N/A, placeholder blanket setting
		#saveTo			: null # N/A, placeholder blanket setting

		###
			When true	: Render and watch routines to go off in the background on construction
			When false	: You must yield templater.initialize()
		###
		autoInitialize	: false
		autoConstruct	: true # when true, constructs lance.templater, like lance.router, lance.cache


		###
			When false	: No debug information is output
			When true	:
				Minimal debug information is output to stdout.

				If an object, then maximum debug can be output:
					debug:
						files	: true
						merge	: true
						render	: true
						watch	: true
		###
		debug			: false

		###
			When not truthy: No merging
			Else:
				[
					{
						saveTo: './relative/path.js'

						# Files array, order is maintained
						files: [

							# String path relative to findIn directory
							'./js/file.js'

							# RegExp match relative to findIn directory
							# This can match multiple files
							/// js/lib/.+\.js$ ///i

						]
					}
				]

			Can specify any js/coffee/css/stylus files.

		###
		bundle		: {}
		browserify:
			extensions: [ '.js', '.coffee' ]


		###
			Causes files to maintain their directory structure on render.
			Assuming /findInDirectory/path/of/file.js we then save it accordingly:
				true	: /saveToDirectory/path/of/file.js
				false	: /saveToDirectory/file.js
		###
		preserveDirectory: true


		watchTimeout	: 1500	# Time between each watch change event on a particular file before the file is re-rendered
		writeTimeout	: 250	# Used to prevent frequent re-writing

		ect:
			engine	: undefined
			ext		: '.ect'
			findIn	: ''
			minify	: true

			options: # options object that is passed when initiating an ECT engine
				root	: ''
				cache	: true
				ext		: ''
				watch	: true
				open	: '<?'
				close	: '?>'
			
		stylus:
			ext		: '.styl'
			engine	: undefined
			saveTo	: './static'
			findIn	: ''
			inherit	: true
			minify	: true
			options	:
				'include css': true
		
		coffee:
			ext		: '.coffee'
			engine	: undefined
			saveTo	: './static'
			findIn	: ''
			options	: {}
			minify	: false
			inherit	: true
		css:
			minify	: true
			ext		: '.css'
			saveTo	: ''
			findIn	: ''
			inherit	: true # Inherits saveTo and findIn, if they aren't set, from stylus

		js:
			minify	: true
			ext		: '.js'
			saveTo	: ''
			findIn	: ''
			inherit	: true # Inherits saveTo and findIn, if they aren't set, from coffee

		# Copy over any whitelisted file to the saveTo directory
		assets:
			saveTo	: './static'
			findIn	: ''
			match	: /// \.(
				png|jpg|gif|ico
			|	woff|eot|ttf|svg|pdf
			)$ ///i

	# templater:
	# 	#findIn			: null # N/A, placeholder blanket setting
	# 	#saveTo			: null # N/A, placeholder blanket setting

	# 	###
	# 		When true	: Render and watch routines to go off in the background on construction
	# 		When false	: You must yield templater.initialize()
	# 	###
	# 	autoInitialize	: false
	# 	autoConstruct	: true # when true, constructs lance.templater, like lance.router, lance.cache


	# 	###
	# 		When false	: No debug information is output
	# 		When true	:
	# 			Minimal debug information is output to stdout.

	# 			If an object, then maximum debug can be output:
	# 				debug:
	# 					files	: true
	# 					merge	: true
	# 					render	: true
	# 					watch	: true
	# 	###
	# 	debug			: false

	# 	###
	# 		When not truthy: No merging
	# 		Else:
	# 			[
	# 				{
	# 					saveTo: './relative/path.js'

	# 					# Files array, order is maintained
	# 					files: [

	# 						# String path relative to findIn directory
	# 						'./js/file.js'

	# 						# RegExp match relative to findIn directory
	# 						# This can match multiple files
	# 						/// js/lib/.+\.js$ ///i

	# 					]
	# 				}
	# 			]

	# 		Can specify any js/coffee/css/stylus files.

	# 	###
	# 	merge		: []
	# 	mergeOnly	: false # When true: Only files specified in the merge list are saved

		
	# 		Causes files to maintain their directory structure on render.
	# 		Assuming /findInDirectory/path/of/file.js we then save it accordingly:
	# 			true	: /saveToDirectory/path/of/file.js
	# 			false	: /saveToDirectory/file.js
		
	# 	preserveDirectory: true


	# 	watchTimeout	: 1500	# Time between each watch change event on a particular file before the file is re-rendered
	# 	writeTimeout	: 250	# Used to prevent frequent re-writing

	# 	ect:
	# 		engine	: undefined
	# 		ext		: '.ect'
	# 		findIn	: ''
	# 		minify	: true

	# 		options: # options object that is passed when initiating an ECT engine
	# 			root	: ''
	# 			cache	: true
	# 			ext		: ''
	# 			watch	: true
	# 			open	: '<?'
	# 			close	: '?>'
			
	# 	stylus:
	# 		ext			: '.styl'
	# 		engine		: undefined
	# 		saveTo		: './static'
	# 		findIn		: ''
	# 		options		: {}
	# 		minify		: true
	# 		watch		: true
	# 		inherit		: true
	# 		render			: true
		
	# 	coffee:
	# 		ext		: '.coffee'
	# 		engine	: undefined
	# 		saveTo	: './static'
	# 		findIn	: ''
	# 		options	: {}
	# 		minify	: true
	# 		watch	: true
	# 		inherit	: true
	# 		render	: true

	# 	css:
	# 		minify	: true
	# 		ext		: '.css'
	# 		saveTo	: ''
	# 		findIn	: ''
	# 		watch	: true
	# 		inherit	: true # Inherits saveTo and findIn, if they aren't set, from stylus
	# 		render	: true

	# 	js:
	# 		minify	: true
	# 		ext		: '.js'
	# 		saveTo	: ''
	# 		findIn	: ''
	# 		watch	: true
	# 		inherit	: true # Inherits saveTo and findIn, if they aren't set, from coffee
	# 		render	: true

	# 	# Copy over any whitelisted file to the saveTo directory
	# 	assets:
	# 		saveTo	: './static'
	# 		findIn	: ''
	# 		match	: /// \.(
	# 				png|jpg|gif
	# 			|	woff|eot|ttf|svg
	# 			)$ ///i
	# 		watch	: true
	# 		render	: true
