# Browser ready

{ typeOf, isIterable } = require './utils'

###
	Parses a string of javascript object notation into its representation and sets an end value

	@param obj {Object} 'info[1].prop'
	@param value {Object} 'value!'
	@return {Object} { info: [ , { prop: 'value!' } } ] }
###
module.exports	=
transpose		= (bindings, value) ->
	if typeof bindings is 'string'
		key			= bindings
		bindings	= {}
		bindings[ key ]	= value

	for binding, value of bindings
		parts = binding.match ///
				([\w]+)
			|	(\[ ["']?[^\[]+["']? \])
		///g

		map = []
		for item in parts
			if key = ( item.match ///
				^ \[ ([^\[]+) \] $
			/// )?[1]
				if /^\d+$/.test key
					parent	= []
					key		= parseInt key
				else
					key		= key.replace /^['"]|['"]$/g, ''
					parent	= {}
			else
				key		= item
				parent	= {}

			map.push { key, parent }

		continue if not map.length

		next = bindings
		last = map[0]

		if map[0].key isnt binding
			delete bindings[ binding ]

		for item, index in map[1..]
			if last.key not of next
				next[ last.key ] = item.parent
			
			next = next[ last.key ]
			last = item

		next[ last.key ] = value

	return bindings

transpose.set = (transposed, data, val) ->
	if typeOf.String transposed
		transposed = transpose transposed, val

	transpose.merge.force data, transposed

###
	Merges between two objects/arrays yet preferres obj2 values when @param `force` is true
###
transpose.merge = (obj1, obj2, depth = 16, force) ->
	if depth > 0
		for own key of obj2
			val1			= obj1[key]
			val2			= obj2[key]
			val1Type		= typeOf val1
			val2Type		= typeOf val2
			val1Iterable	= isIterable val1, val1Type
			val2Iterable	= isIterable val2, val2Type

			if key of obj1
				if val1Iterable and val2Iterable
					if (
						force and (
							val1Type isnt val2Type or
							( val2Type is 'array' and not val2.length ) or
							( val2Type is 'object' and not Object.keys( val2 ).length > 0 )
						)
					)
						obj1[key] = val2
					else
						console.log val1Type is 'object', Object.keys( val1 ).length
						arguments.callee val1,  val2, depth - 1, force
				else if force
					obj1[key] = val2
			else
				obj1[key] = val2

	return obj1

transpose.merge.force = (obj1, obj2, depth) ->
	transpose.merge obj1, obj2, depth, true

transpose.find = (transposed, data) ->
	iterator = (pos1, pos2) ->
		if ( state1 = isIterable( pos1 ) ) and ( state2 = isIterable( pos2 ) )
			break for key1, val1 of pos1

			if key1 of pos2
				return iterator val1, pos2[ key1 ]
		else if not state1
			return pos2
		
		return undefined

	return iterator transposed, data
