
Promise	= require 'bluebird'
path	= require 'path'
fs		= Promise.promisifyAll require 'fs'
utils	= require './utils'

{ typeOf } = utils

utils.exploreDir = (dir, o, fileIterator) ->
	if typeOf.Function o
		fileIterator	= o
		o				= {}

	depth			= o.depth or 6
	ignorePrefix	= if o.ignorePrefix? then o.ignorePrefix else '_'

	iterator = Promise.coroutine (dir, depth) ->
		return null if --depth < 0
		
		filenames = yield fs.readdirAsync dir

		await = []

		for filename in filenames then do (filename) ->
			filePath = path.resolve path.join dir, filename

			await.push fs.statAsync( filePath ).then (stats) ->
				if filename[0] is ignorePrefix or not stats
					return null

				if stats.isDirectory()
					if o.directory
						o.directory filePath, stats

					return iterator filePath, depth

				else if stats.isFile() and o.file
					return fs.readFileAsync( filePath, 'utf8' ).then (file) ->
						ext		= path.extname filename
						name	= path.basename filename, ext

						o.file file, filePath, filename, name, ext

		yield return Promise.all await

	return iterator dir, depth

utils.inspect = (vari, depth = 6, showHidden = true, colors = true) ->
	require('util').inspect vari, { depth, showHidden, colors }
	
###
# Explores a directory and subdirectories.
utils.exploreDir = (dir, opt = {}) ->
	return false if not dir or typeof dir isnt 'string'

	explore = (dir, opt) =>
		return false if opt.depth < 1

		for filename in fs.readdirSync dir
			ext			= path.extname filename
			name		= path.basename filename, ext
			filepath	= path.resolve path.join dir, filename
			stats		= fs.statSync filepath
			
			continue if	filename[0] is opt.ignoreChar or not stats

			if stats.isDirectory()
				if opt.onFolder
					if ( opt.onFolder filepath ) isnt false
						arguments.callee filepath, opt
				else
					arguments.callee filepath, opt
				
			else if stats.isFile()
				file = fs.readFileSync filepath, 'utf8'

				if opt.onFile
					if opt.onFile( file, filepath, filename, name, ext ) is false
						break
	
	if utils.typeOf.Function opt
		opt = { onFile: opt }

	opt.onFile		= opt.onFile		or false
	opt.onFolder	= opt.onFolder		or false
	opt.ignoreChar	= opt.ignoreChar	or '_'
	opt.depth		= opt.depth			or 6

	return explore dir, opt
###